<?php
#=============================================================================================================================
#	File Name		:	mls_config2.php
#=============================================================================================================================
define('IN_ADMIN', 	true);
define('MODULE_KEY',	'Mls-Config');

ini_set("memory_limit","50M");  //set memory to 50Meg
ini_set("max_execution_time", 14400); // 4hrs should be sufficent? ( 240 minutes * 60 seconds = 14400 seconds)

# Include the required file
include_once("../includes/common.php");
//include_once($physical_path['Libs']. "/phrets.php");
include_once($physical_path['Libs']."/PHRETS/vendor/autoload.php");

#=============================================================================================================================
# Define the action
#-----------------------------------------------------------------------------------------------------------------------------
$mls_id = isset($_GET['mls_id']) ? $_GET['mls_id'] : (isset($_POST['mls_id']) ? $_POST['mls_id'] : '0');
$step = isset($_GET['step']) ? $_GET['step'] : (isset($_POST['step']) ? $_POST['step'] : 'Class');

# Initialize object with required module
MLSConfig::obj(true);

//$rets 			= new phRETS();

$rsMLSData = MLSMaster::obj()->getInfoById($mls_id);

if (isset($_POST['Submit']) && $_POST['Submit']=='Save')
{
	$ret = MLSConfig::obj()->_Insert($mls_id, $_POST);
	header('location: mls_config.php?mls_id='.$mls_id.'&step=Class');
	exit(0);
}
#-----------------------------------------------------------------------------------------------------------------------------
#	Cancel
#-----------------------------------------------------------------------------------------------------------------------------
elseif(isset($_POST['Submit']) && $_POST['Submit'] == 'Cancel')
{
	if ($step=='Class')
		header('location: mls_master.php');
	else
		header('location: mls_config.php?mls_id='.$mls_id.'&step=Class');

	exit(0);
}

$retconfig = new \PHRETS\Configuration;

$retconfig->setLoginUrl(MLS_TREB::obj()->Config['MLS_Host'])
	       ->setUsername(MLS_TREB::obj()->Config['MLS_User'])
	       ->setPassword(MLS_TREB::obj()->Config['MLS_Passwd'])
           ->setRetsVersion(MLS_TREB::obj()->Config['MLS_Version'])
           ->setUserAgent(MLS_TREB::obj()->Config['MLS_User_Agent'])
            ->setUserAgentPassword(MLS_TREB::obj()->Config['MLS_User_Agent_Passwd']) // string password, if given
            ->setHttpAuthenticationMethod('digest') // or 'basic' if required 
            ->setOption('use_post_method', true) // boolean
            ->setOption('disable_follow_location', false); // boolean
    //$rets->SetParam("debug_mode", true);
    //$rets->SetParam("debug_file", $physical_path['Cronjob'].'/rsrets/log/rets_debug.txt');

    //echo "+ Connecting to Server<br>\n";
    $rets = new \PHRETS\Session($retconfig);
   // $connect = $rets->Connect(MLS_TREB::obj()->Config['MLS_Host'],  MLS_TREB::obj()->Config['MLS_User'], MLS_TREB::obj()->Config['MLS_Passwd'], MLS_TREB::obj()->Config['MLS_User_Agent_Passwd']);
   $connect = $rets->Login();
    // check for errors
    if ($connect) {
        //echo "  + Connected<br>\n";
    }
    else {
        echo "  + Not connected:<br>\n";
        print_r($rets->Error());
        exit;
    }

//print $results;exit;
/*if (!$results)
{
	header('location: mls_master.php?connection=false');
	exit(0);
}*/


//$group_Name =  array();
//$MappedList =   array();
//Utility::pre($step);
$system_meta = $rets->GetSystemMetadata();
if ($step=='Class')
{
	$get_Resource = MLSConfig::obj()->arrResourceFromRETS2($system_meta);
	//Utility::pre($get_Resource);
    $group_Name =  array();
    $MappedList = array();
	//print "<pre>";print_r($get_Resource);exit;
	$get_Data =  array();

	foreach ($get_Resource as $resource => $resourceData)
	{
		$arr_Data = MLSConfig::obj()->arrClassFromRETS2($rets, $resource);
		$get_Data[$resource] = $arr_Data;
	}
    //Utility::pre($get_Data);
	$results = $rets->Disconnect();
	$arr_Select_Data = MLSConfig::obj()->getKeyValueClass($mls_id);
    //Utility::pre($arr_Select_Data);
}
if (($step=='SelectQuery') || ($step=='Mapping'))
{
	if (isset($_GET['Resource']) && isset($_GET['Class']))
		$Record = MLSConfig::obj()->getAllbyParam($mls_id, $_GET['Resource'], $_GET['Class']);
	else
		$Record = MLSConfig::obj()->getAllbyRETS($mls_id);
	//Utility::pre($Record);
	$group_Name =  array();
	$get_Data =  array();
	$arr_Resource =  array();

	if ($step=='Mapping')
		$get_lookup_Data = array();

	foreach ($Record as $key => $recArr)
	{
	   	$arr_Class = MLSConfig::obj()->arrClassFromRETS2($rets, $recArr['Resource']);
		//Utility::pre($recArr);
		MLSConfig::obj()->arrTableFromRETS2($rets, $recArr['Resource'], $recArr['Class'], $arr_Data, $lookup_Data);

		$arr_Resource[$recArr['Resource'].'_'.$recArr['Class']] = $recArr['Resource'];
		$group_Name[$recArr['Resource'].'_'.$recArr['Class']] = $recArr['Resource'].' : '.$arr_Class[$recArr['Class']];
		$MappedList = unserialize($recArr['MappedList']);

        if ($step=='Mapping')
		{
			$SelectQuery = explode(',',$recArr['SelectQuery']);
			//$MappedList = unserialize($recArr['MappedList']);

			$Field_Select =  array();
			$Field_Lookup =  array();
            if(is_array($SelectQuery) && count($SelectQuery) > 1)
            {
                foreach ($SelectQuery as $key => $val)
    			{
    				$Field_Select[$val] = $arr_Data[$val];
    				$Field_Lookup[$val] = $lookup_Data[$val];
    			}
    			$get_Data[$recArr['Resource'].'_'.$recArr['Class']] = $Field_Select;
    			$get_lookup_Data[$recArr['Resource'].'_'.$recArr['Class']] = $Field_Lookup;
            }

		}
		else
			$get_Data[$recArr['Resource'].'_'.$recArr['Class']] = $arr_Data;
	}

	$results = $rets->Disconnect();

	if ($step=='SelectQuery')
	{
		$arr_Select_Data = MLSConfig::obj()->getKeyValueCustom($mls_id, $_GET['Resource'], $_GET['Class'], 'SelectQuery', 'SelectQuery');
	}
	if ($step=='Mapping')
	{
		$arr_Select_Data = MLSConfig::obj()->getKeyValueCustom($mls_id, $_GET['Resource'], $_GET['Class'], 'SelectQuery', 'FieldList');
		$SelectLookup = MLSConfig::obj()->getKeyValueCustom($mls_id, $_GET['Resource'], $_GET['Class'], 'LookupList', 'LookupList');

        if (count($arr_Select_Data[$_GET['Resource'].'_'.$_GET['Class']])==0)
		{
		  //Utility::pre($get_Data);
			foreach ($get_Data[$_GET['Resource'].'_'.$_GET['Class']] as $key => $val)
			{
				if (array_search($val,MLSConfig::obj()->arrFieldList[$_GET['Resource']]))
				{
					$arr_Select_Data[$_GET['Resource'].'_'.$_GET['Class']][$key] = array_search($val,MLSConfig::obj()->arrFieldList[$_GET['Resource']]);
				}
			}
        }
	}
}
#=============================================================================================================================
#											RESPONSE CREATING CODE
#-----------------------------------------------------------------------------------------------------------------------------
st::$obj->assign(array( "T_Body"			=>	'custom_addedit'. $config[TPL_EX] ,
				   	"includeFile"		=>	'mls_config'. $config[TPL_EX] ,
					"arr_Data"			=>	$get_Data,
					"arr_Select_Data"	=>	$arr_Select_Data,

					"Step"				=>	$step,
					"MLS_ID"			=>	$mls_id,
                    "arrGroup"			=>	$group_Name,
                    "MappedList"		=>	$MappedList,
					"A_Action"			=>	"mls_config.php?mls_id=".$mls_id."&step=".$step,
					//"succMessage"		=>	$succMessage,
					'msgSuccess'		=>	$msgSuccess,
					'L_Module'			=>	MLSConfig::obj()->Data['L_Module'],
					//'L_Module_Id'		=>	MLSConfig::obj()->Data['L_Module_Id'],
					//'H_HelpText'		=>	MLSConfig::obj()->Data['H_AddEdit'],
					//'F_FieldInfo'		=>	MLSConfig::obj()->Data['F_FieldInfo'],
					));

if ($step=='Mapping')
{
	/*print "<pre>";
	print_r($get_lookup_Data);
	print_r($SelectLookup);
	exit;*/
	st::$obj->assign(array( "arrResource"	=>	$arr_Resource,
						"arrFieldList"	=>	MLSConfig::obj()->arrFieldList,
						"lookup_Data"	=>	$get_lookup_Data,
						"SelectLookup"	=>	$SelectLookup,
						));
}

st::$obj->display('default_layout'. $config[TPL_EX] );
?>