var map;
var geocoder;
var marker;

$(document).ready(function(){
    
    var lati  = parent.$('#Latitude').val();
	var longi = parent.$('#Longitude').val();
    loadGoogleMap('map-holder', lati, longi);  
})

function loadGoogleMap(mapHolder, lat, long)
{
    var myOptions = {
					  zoom: 14,
					  center: new google.maps.LatLng(34.052235,-118.243683),
					  mapTypeId: google.maps.MapTypeId.ROADMAP,
					  scrollwheel:false,
					  mapTypeControl: false
					};
	
	map = new google.maps.Map(document.getElementById(mapHolder), myOptions);
	// We are on Full view page
	if(parseFloat(lat) > 0)
	{
		setMarker(lat, long);	
	}		
	
	geocoder = new google.maps.Geocoder();
}

function getLocation()
{
	$('#map-msg').hide();
	
	var address = '';
	
	if(parent.$('#Address').val() != '')
		address += parent.$('#Address').val() + " ";
    else
    {
        if(parent.$('#StreetNumber').val() != '')
            address += parent.$('#StreetNumber').val() + " ";
        if(parent.$('#StreetName').val() != '')
            address += parent.$('#StreetName').val() + " ";
        if(parent.$('#StreetSuffix').val() != '')
            address += parent.$('#StreetSuffix').val() + " ";
        if(parent.$('#CityName').val() != '')
            address += parent.$('#CityName').val() + " ";
        /*if(parent.$('#StreetNumber').val()= '')
            address += parent.$('#StreetNumber').val() + " ";
        if(parent.$('#StreetNumber').val()= '')
            address += parent.$('#StreetNumber').val() + " ";*/
    }
					
	if(address != '')
	{
		address = $.trim(address);
		//console.log(address);
		geocoder.geocode( { 'address': address}, function(results, status) {
		  if (status == google.maps.GeocoderStatus.OK) {
			  
			setMarker(results[0].geometry.location.lat(), results[0].geometry.location.lng());
			
			//console.log(results[0].geometry.location);
			parent.$('#Latitude').val(results[0].geometry.location.lat());
			parent.$('#Longitude').val(results[0].geometry.location.lng());
			
			$('#map-msg').hide();
		  } else {
			//alert("Sorry! no location found.");			
			$('#map-msg').show();
		  }
		});
	}
}

function setMarker(lat, long, isManual)
{
	var latlong = new google.maps.LatLng(lat, long);
	
	map.setCenter(latlong);
	
	if(marker)
	{
		marker.setMap(null);
	}
	
	marker = new google.maps.Marker({
		map: map,
		position: latlong,
		draggable: ($('#View-Project').length ? false : true)
	});
	
	if(!$('#View-Project').length)
	{
		google.maps.event.addListener(marker, 'dragend', function(){
	
				parent.$('#Latitude').val(this.position.lat());
				parent.$('#Longitude').val(this.position.lng());
		});
	}
	
	if(isManual == 'Yes')
	{
		map.setZoom(12);
	}
	else
	{
		map.setZoom(12);
	}
	
	$('#map-msg').hide();
}


function removeMarker()
{
	if(marker)
	{
		marker.setMap(null);
	}
	
	parent.$('#Latitude').val('');
	parent.$('#Longitude').val('');
}
