// JavaScript Document
$(document).ready(function() {
	
	$("input[name=user_date_period]").click( function(){
				var value = $(this).val();									  		
				if(value == 'Period')
				{
					$("#show_date_range").show('slow');
				}
				else
				{
					$("#show_date_range").hide('slow');
				}
	});	
	
	// Validate First Step
	if($("#frmSendMail_step1").length)
	{
		$("#frmSendMail_step1").validate({
								   
			submitHandler: function(frm) {
				
				// Report type available ?
				if($(".report-type").length)
				{
					// Report Type Selected ?
					var lenRepType = $(".report-type:checked").length;
					if(lenRepType == 0)
					{
						alert('Please select atleast one Report Type.');
						return false;
					}	
				}
				
				// Validate other information if entered any
				var elsName		= $("#frmSendMail_step1 input[name$='[first_name]']");
				var elsEmail	= $("#frmSendMail_step1 input[name$='[email]']");
												
				var totalOtherUser = 0;
				
				for(i=0; i<elsName.length; i++)
				{												
					if($(elsName[i]).val() != '' || $(elsEmail[i]).val() != '')
					{															
						$(elsName[i]).rules("add", {required: true});
						$(elsEmail[i]).rules("add", {required: true, email: true});					
					}
					else
					{
						$(elsName[i]).rules("remove");
						$(elsEmail[i]).rules("remove");
					}
					
					if($(elsName[i]).val() != '' && $(elsEmail[i]).val() != '')
						totalOtherUser++;
						
				}
			
				if($("#frmSendMail_step1").valid())
				{
					var totalUserSelected = $("input[name^='user_id[]']:checked").length;
					
					// Not select any user nor entered other user information ? display alert
					if(totalUserSelected == 0 && totalOtherUser == 0)
					{
						alert("Please select users from available list or enter other users information");
						
						return false;
					}
					
					// Get selected Listing Ids
					if($('#mlsId').val() == '')
					{
						getSelectedlisting();
					}
					
					frm.submit();
					return true;
				}
			}
		});	
	}
	
	// Validate Second Step
	if($("#frmSendMail_step2").length)
	{
		$("#frmSendMail_step2").validate({
								   
			submitHandler: function(frm) {
															
				// Report type available ?
				if($(".report-type").length)
				{
					// Report Type Selected ?
					var lenRepType = $(".report-type:checked").length;
					if(lenRepType == 0)
					{
						alert('Please select atleast one Report Type.');
						return false;
					}
				
				}
				
				// Validate other information if entered any
				var elsName		= $("#frmSendMail_step2 input[name$='[first_name]']");
				var elsEmail	= $("#frmSendMail_step2 input[name$='[email]']");
				
				var totalOtherUser = 0;
				
				for(i=0; i<elsName.length; i++)
				{												
					if($(elsName[i]).val() != '' || $(elsEmail[i]).val() != '')
					{															
						$(elsName[i]).rules("add", {required: true});
						$(elsEmail[i]).rules("add", {required: true, email: true});					
					}
					else
					{
						$(elsName[i]).rules("remove");
						$(elsEmail[i]).rules("remove");
					}
					
					if($(elsName[i]).val() != '' && $(elsEmail[i]).val() != '')
						totalOtherUser++;
						
				}
			
				if($("#frmSendMail_step2").valid())
				{
					if($("#selUserCount").val() == 0 && totalOtherUser == 0)
					{
						alert("Please enter atleast one user information to send mail");
						
						return false;
					}
												
					if(!IsEmpty(document.getElementById("email_subject"), 'Please enter Email Subject.'))
					{
						return false;
					}
					
					// Get selected Listing Ids					
					if($('#mlsId').val() == '')
					{
						getSelectedlisting();
					}
					
					frm.submit();
					return true;
				}
			}
		});	
	}
    
    if($("table#sieve").length > 0)
    {
        $("table#sieve").sieve({
            searchTemplate: "<div><label>Quick Search: <input type='text'></label></div>",
        });    
    }
});

/*====================================================================================================
	Function Name	:	CEmailChecked_Click()
----------------------------------------------------------------------------------------------------*/
function CEmailChecked_Click(frm, PK)
{
	with(frm)
	{
		var flg = false;
		var cntChecked = 0;
		
		for(i=0; i < PK.length; i++)
		{
			if(PK[i].checked)
			{
				cntChecked++;
				flg = true;
			}
		}

		if(!flg || cntChecked < 2)
		{
			alert('Please select atleast two property you want to send in email.');
			return false;
		}
		
		$("#hlnk_email_mul_user").trigger('click');
		
		return false;
	}
}

/*====================================================================================================
	Function Name	:	getSelectedlisting()
----------------------------------------------------------------------------------------------------*/
function getSelectedlisting()
{
	var values = new Array();
	$.each(parent.$("input[name^='pk_list[]']:checked"), function() {values.push($(this).val());});
	var listingIDs = values.join(",");	
	if(listingIDs != '')
	{		
		$('#mlsId').val(listingIDs);
	}
}
/*====================================================================================================
	Function Name	:	ViewReport_Click()
----------------------------------------------------------------------------------------------------*/
function ViewReport_Click(rep_foramt)
{	
	if($("#mlsId").val() == '')
		getSelectedlisting();
		
	window.open('listing-report.php?report-type='+rep_foramt+'&mls_no='+$("#mlsId").val()+'&exclusive='+$("#show_assessed_value").val(), 'Property Report View');
}
/**
 * Add row to table body
 *
 * @param	elHolder	id of element holder
 */
function addDataCol(elHolder, tmpl, elType) {
	
	/* Clone table */
	var template = jQuery.format($('#'+ tmpl).val());

	var ele = $('#'+ elHolder);

	var index = (+ele.data('Index'))||0;
			
	if(index == 0)
		index = $('#'+ elHolder).children().size();
	else
		index++;
		
	$(template(index)).appendTo(ele);

	/* Save element index */
	ele.data('Index', index);
}
/**
 * Remove row from table body
 *
 * @param	elHolder	id of element holder
 */
function removeDataCol(el, opt) {

	/* Get row count */
	var parentEle = $(el).parent().parent().parent();	
	var removeEle = $(el).parent().parent();	
	var cnt = $(el).parent().parent().parent().children('tr').size();

	/* Before deleting saving the count */
	var index = (+parentEle.data('Index'))||0;

	if(index == 0)
		parentEle.data('Index', cnt);
	
	/* Row with title*/
	cnt--;

	/* If greter than minium size, then remove it */
	if(cnt > opt.Mimimum)
		removeEle.remove();
}

/*function Fill_County(state_code)
{
	if(state_code != '')
		xajax_GetData('GeoCounty','getCounty',{stateCode:state_code});
}*/

//====================================================================================================
//	Function Name	:	Fill_City
//----------------------------------------------------------------------------------------------------
function Fill_City(strCounty)
{	
	var state_code = $('#user_state').val();
	xajax_GetData('GeoCounty', 'FillCity',{county_name:strCounty,stateCode:state_code});	
}

function addListData(s, d)
{	
	var len = s.options.length;
	var i = 0;
	var j = 0;
	
	while(i<len)
	{
		if(s.options[j].selected == true)
		{
			var k = d.options.length;
			d.options[k] = new Option(s.options[j].text, s.options[j].value);			
			s.remove(j);
		}
		else
			j++;
		i++;
	}
}

function getValues(s, d)
{
	var len = s.options.length;
	var i = 0;
	var str = '';
	
	while(i<len)
	{
		if (str!='')
			str += ",";

		str += s.options[i].value;
		
		i++;
	}
	d.value = str;
}

//====================================================================================================
//	Function Name	:	Fill_Template_Details()
//----------------------------------------------------------------------------------------------------
function Fill_Template_Details(strVal)
{	
	//xajax_UserAjaxCall('EmailTemplate', 'Load', {emailId:strVal});
     var send_data = [];
     send_data.push({name:'emailId',value:strVal});
     jQuery.jAjaxCall({
                        xhr_area    :   'User',
                        xhr_module  :   'LoadEmailTemplate',
                        xhr_action  :   '',
                        send_data   :    send_data,
                        xhr_url     :   'ajax-request.php'
                    },'loademailtemplate');		
}

//====================================================================================================
//	Function Name	:	Fill_Template_Details()
//----------------------------------------------------------------------------------------------------
function FetchEmailTemplates(strVal)
{
	var email_category = '';
	
	if($("#email_category").length)
	{
		email_category = $("#email_category").val();
	}
	
	if($("#master_email_id").val() > 0)
    {
		//xajax_UserAjaxCall('EmailTemplate', 'TemplateDetail', {agentId:strVal, master_email_id:$("#master_email_id").val()});
        var send_data = [];
        send_data.push({name:'agentId',value:strVal});
        send_data.push({name:'master_email_id',value:$("#master_email_id").val()});
        
        jQuery.jAjaxCall({
                        xhr_area    :   'User',
                        xhr_module  :   'TemplateDetailEmailTemplate',
                        xhr_action  :   '',
                        send_data   :    send_data,
                        xhr_url     :   'ajax-request.php'
                    },'loademailtemplate');	
        
    }    
	else
    {
		var send_data = [];
        send_data.push({name:'agentId',value:strVal});
        send_data.push({name:'email_category',value:email_category});
        //xajax_UserAjaxCall('EmailTemplate', 'FetchKeyValArray', {agentId:strVal, email_category:email_category});
        jQuery.jAjaxCall({
                        xhr_area    :   'User',
                        xhr_module  :   'FetchKeyValArrayEmailTemplate',
                        xhr_action  :   '',
                        send_data   :    send_data,
                        xhr_url     :   'ajax-request.php'
                    },'loademailtemplate');	
    }
}