<?php
#=============================================================================================================================
#	File Name		:	MLSMaster.php
#=============================================================================================================================
# Include data
//require_once(dirname(__FILE__) . '/MLSMasterData.php');

class NonMLSListingMaster extends CustomClass
{
    public static $Instance;

	public static function obj()
	{
		if(!is_object(self::$Instance))
			self::$Instance = new self();

		return self::$Instance;
	}
    #=========================================================================================================================
	#	Function Name	:   NonMLSListingMasterData
	#	Purpose			:	Simple constructor
	#	Return			:	None
	#-------------------------------------------------------------------------------------------------------------------------
    public function __construct()
    {
		global $physical_path, $virtual_path, $asset, $config;

		# Initialize all default data

		# Table name
		$this->Data['TableName']			=	$config['Table_Prefix']. 'non_mls_listing_master';

		# Module title
		$this->Data['L_Module']				=	'Non MLS Listing Master';

		# Primary field info
		$this->Data['F_PrimaryKey']			=	'id';


		# Intialize parent class
		parent::__construct();
	}
    #=========================================================================================================================
    #	Function Name	:   Insert
    #	Purpose			:	Insert new information
    #	Return			:	Return insert status
    #-------------------------------------------------------------------------------------------------------------------------
    public function InsertNonMLSListings($arrdata, $document_id, $RPLResult)
    {
        $array = array();
        $arrMls = DocumentMaster::obj()->getDocument($document_id);

        if ($arrMls != null && count($arrMls) > 0){
            if(count($arrMls) == 1)
                $mls_num= $arrMls['mls_num'];
            else{
                $arrmlsdata = [];
                foreach ($arrMls as $k=>$v){
                    $arrmlsdata[] = $v;
                }
                $mls_num = implode(",", $arrmlsdata);
            }
        }
        else{
            $mls_num= "";
        }
        global $db;
        $POST = [];
        $POST['parid']                  = $arrdata-> parid;
        $POST['borough']                = $arrdata-> boro;
        $POST['block']                  = $arrdata-> block;
        $POST['lot']                    = $arrdata-> lot;
        $POST['property_type']          = $RPLResult->property_type;
        $POST['street_number']          = $RPLResult-> street_number;
        $POST['street_name']            = $arrdata-> street_name;
        $POST['unit']                   = isset($RPLResult-> unit)?$RPLResult-> unit:"";
        $POST['housenum_lo']            = $arrdata-> housenum_lo;
        $POST['housenum_hi']            = $arrdata-> housenum_hi;
        $POST['zip_code']               = $arrdata-> zip_code;
        $POST['bld_story']              = $arrdata-> bld_story;
        $POST['yrbuilt']                = $arrdata-> yrbuilt;
        $POST['yralt1']                 = $arrdata-> yralt1;
        $POST['aptno']                  = $arrdata-> aptno;
        $POST['appt_boro']              = $arrdata-> appt_boro;
        $POST['appt_block']             = $arrdata-> appt_block;
        $POST['appt_lot']               = $arrdata-> appt_lot;
        $POST['condo_number']           = $arrdata-> condo_number;
        $POST['residential_area_gross'] = $arrdata-> residential_area_gross;


        $sql =	" INSERT INTO ".$this->Data['TableName'].
            " (parid, mls_num, document_id, borough, block, lot, property_type, street_number, street_name, unit, housenum_lo, housenum_hi, zip_code, bld_story, yrbuilt, yralt1, aptno, appt_boro, appt_block, appt_lot, condo_number, residential_area_gross)".
            " VALUES ('".$POST['parid']."', 
                      '".$mls_num."', 
                      '".$document_id."', 
                      '".$POST['borough']."', 
                      '".$POST['block']."', 
                      '".$POST['lot']."', 
                      '".$POST['property_type']."', 
                      '".$POST['street_number']."', 
                      '".$POST['street_name']."', 
                      '".$POST['unit']."', 
                      '".$POST['housenum_lo']."', 
                      '".$POST['housenum_hi']."', 
                      '".$POST['zip_code']."', 
                      '".$POST['bld_story']."', 
                      '".$POST['yrbuilt']."', 
                      '".$POST['yralt1']."', 
                      '".$POST['aptno']."', 
                      '".$POST['appt_boro']."', 
                      '".$POST['appt_block']."', 
                      '".$POST['appt_lot']."', 
                      '".$POST['condo_number']."', 
                      '".$POST['residential_area_gross']."'
                      )".
            " ON DUPLICATE KEY UPDATE parid = VALUES(parid), mls_num = VALUES(mls_num), document_id = VALUES(document_id), block = VALUES(block), lot = VALUES(lot), unit = VALUES(unit); ";

        $val = $db->query($sql);
        $last_id = $db->Link_ID->insert_id;
        
        if($last_id == 0){
            $sql=" SELECT id FROM ".$this->Data['TableName']." WHERE parid=".$POST['parid'];
            if($POST['unit'] != ''){
                $sql.=" AND unit = '".$POST['unit']."'";
            }
            $sql.=" AND block = ".$POST['block'];
            $sql.=" AND lot = ".$POST['lot'];
            $sql.=" AND document_id = ".$document_id;
            if($mls_num != ''){
                $sql.=" AND mls_num = '".$mls_num."'";
            }
            
            file_put_contents('query2.txt', print_r($sql,true), FILE_APPEND);

            $query = $db->query($sql);
            $result = $query->fetch_array();
            
            if(isset($result[0])){
                $last_id = $result[0]['id'];
            }
            else{
                $last_id = 0;
            }
        }
        $array['success']= $val;
        $array['last_id']= $last_id;
        $array['mls_num']= $mls_num;
        
        return $array;
    }

}
?>