<?php
/**
 * @file /includes/global.php
 */

# Store start time
global $t_start;
$mtime      = microtime();
$mtime      = explode(" ",$mtime);
$mtime 	    = $mtime[1] + $mtime[0];
$t_start    = $mtime;

define('IN_SECURE',	true);

if ((! empty($_SERVER['REQUEST_SCHEME']) && $_SERVER['REQUEST_SCHEME'] == 'https') || (! empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on'))
{
	$server_request_scheme = 'https://';
}
else
{
	$server_request_scheme = 'http://';
}

if(isset($_POST['XHR']['AJAX']) && $_POST['XHR']['AJAX'] == 'true')
{
	define('IN_AJAX', true);
	if(isset($_SERVER['HTTP_ORIGIN']))
	{
		header("Access-Control-Allow-Credentials: true");
		header("Access-Control-Allow-Origin: ".$_SERVER['HTTP_ORIGIN']);
	}
}

//ini_set('memory_limit', '1024M');
if(isset($_GET['LT']) || isset($_SESSION['LT']) || (isset($_SERVER['SERVER_PORT']) && strpos($_SERVER['HTTP_HOST'],'.project:'.$_SERVER['SERVER_PORT']) != false))
{
	//ini_set('display_errors', 'off');
	//error_reporting(E_ALL);
   // error_reporting(0); //+E_ERROR | E_WARNING | E_PARSE // This will NOT report uninitialized variables
	error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_STRICT ^E_DEPRECATED);
    //error_reporting(E_ALL);//& ~E_NOTICE & ~E_STRICT
}
else
{
	ini_set('display_errors', 'on');
	//error_reporting(E_ALL);
	error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_STRICT ^E_DEPRECATED);
}

define('ENDUSER_SID_COOKIE',       'NICKSID');
define('ENDUSER_SID_COOKIE_ADMIN', 'NICKRICTEDSID');

if(!defined("IN_CRON") && !defined("IN_ASSETS"))
{
    # Check for IP address fro each request
	if(!isset($_SERVER['REMOTE_ADDR']) || $_SERVER['REMOTE_ADDR'] == ''){exit("Unable to identify your request.");}

	$session_name = ENDUSER_SID_COOKIE;

	if(defined('IN_ADMIN'))
		$session_name = ENDUSER_SID_COOKIE_ADMIN;

	ini_set('session.name', $session_name);

	/*session_save_path("/");*/
	# To share session between sub domain
	$tmpServer = explode('.', $_SERVER['SERVER_NAME']);
    ini_set('session.cookie_domain', '.'.$tmpServer[count($tmpServer)-2]. ".". $tmpServer[count($tmpServer)-1]);

	session_start();

	/*session_regenerate_id();*/
}

date_default_timezone_set('America/New_York');
# Define some basic configuration arrays. This also prevents malicious rewriting of language and otherarray values via URI params
global $config, $physical_path, $virtual_path, $asset, $Debug_info, $msgSuccess, $msgError, $msgWarning, $msgInfo, $css_files, $js_files,$preferences;
$physical_path=array(); $virtual_path=array(); $config=array(); $css_files=array(); $js_files=array(); $preferences=array();

# Set required sub domain
$asset['SUB_DOMAIN_LIST'] = array(
	'STAR'=>'*',    'CDN'=>'cdn',   'MDN'=>'mdn',   'API'=>'api',   'XHR'=>'xhr', 'SECURE'=>'secure',
	'RESPONSE'=>'response','TRACK'=>'track'
);

# Define site state and set site root. Set the server name.
$config['Server_Name']              =   strtoupper($_SERVER['SERVER_NAME']);

if(!defined("IN_CRON"))
{
	if(defined("IN_ADMIN") || defined("IN_API") || defined("IN_AGENT"))
		define("INSTALL_DIR", '..');
	else
		define("INSTALL_DIR", '.');

	$physical_path['Site_Root']		=	INSTALL_DIR;
	$virtual_path['Site_Root']		=	'';
}
else
{
	if(!defined('INSTALL_DIR'))
		define("INSTALL_DIR", '');

	$physical_path['Site_Root']		=	rtrim($_SERVER['DOCUMENT_ROOT']. INSTALL_DIR, "/");
	$virtual_path['Site_Root']		=	INSTALL_DIR;
}

if(defined("IN_CRON"))
{
	$sr=$physical_path['Site_Root'];
	$plorp = substr(strrchr($sr,'/'), 1);
	$physical_path['Server_Root'] = rtrim(substr($sr, 0, - strlen($plorp)),"/");
}
else
{
	$physical_path['Server_Root'] = "../".$physical_path['Site_Root'];
}

$virtual_path['Host_Url']           =	$server_request_scheme. $_SERVER['HTTP_HOST'];

# Forcefully added WWW
if(strpos($_SERVER['HTTP_HOST'], 'project') === false)
	$server_request_scheme .= 'www.';

$urlPart                            =   explode(".", $_SERVER['HTTP_HOST']);
if(strpos($_SERVER['HTTP_HOST'], 'thatsend') !== false)
{
	if(defined("IN_AGENT"))
		$_SERVER['NON_WWW_HTTP_HOST']	= $urlPart[count($urlPart)-4].".".$urlPart[count($urlPart)-3].".". $urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1];
	else
		$_SERVER['NON_WWW_HTTP_HOST']	= $urlPart[count($urlPart)-3].".". $urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1];
}
else
{   if(defined("IN_AGENT"))
		$_SERVER['NON_WWW_HTTP_HOST']	= $urlPart[count($urlPart)-3].".". $urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1];
	else
		$_SERVER['NON_WWW_HTTP_HOST']	= $urlPart[count($urlPart)-2]. ".". $urlPart[count($urlPart)-1];
}

//$_SERVER['NON_WWW_HTTP_HOST']	    =   $urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1];
# Main host name so in case of request from sub domain we can get main http host
if(defined("IN_AGENT"))
{
	$virtual_path['Main_Host_Url']           =	$server_request_scheme.((strpos($_SERVER['HTTP_HOST'],'.project:'.$_SERVER['SERVER_PORT'])===false && strpos($_SERVER['HTTP_HOST'],'thatsend')===false)?'www.':'').((strpos($_SERVER['HTTP_HOST'], 'thatsend') !== false)?$urlPart[count($urlPart)-3].".". $urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1]:$urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1]);
}
else
//	$virtual_path['Main_Host_Url']           =	$server_request_scheme.((strpos($_SERVER['HTTP_HOST'],'.project:'.$_SERVER['SERVER_PORT'])===false && strpos($_SERVER['HTTP_HOST'],'thatsend')===false)?'www.':''). $_SERVER['NON_WWW_HTTP_HOST'];
	$virtual_path['Main_Host_Url']           =	$server_request_scheme.((strpos($_SERVER['HTTP_HOST'],'.project:'.$_SERVER['SERVER_PORT'])===false && strpos($_SERVER['HTTP_HOST'],'thatsend')===false && strpos($_SERVER['HTTP_HOST'],'org')===false)?'':''). $_SERVER['NON_WWW_HTTP_HOST'];


if(strpos($_SERVER['HTTP_HOST'], 'thatsend') !== false)
{
	#DEMO SERVER
	foreach($asset['SUB_DOMAIN_LIST'] as $k=>$d)
	{$virtual_path[$k.'_Url'] =	$server_request_scheme.$_SERVER['HTTP_HOST'];}
}
else
{
	#LIVE SERVER
	foreach($asset['SUB_DOMAIN_LIST'] as $k=>$d)
	{
		if(defined("IN_AGENT") && $k == 'XHR')
			$virtual_path[$k.'_Url'] =	$server_request_scheme.$_SERVER['HTTP_HOST'];//'http://'.$_SERVER['NON_WWW_HTTP_HOST'];
		elseif(defined("IN_AGENT"))
			$virtual_path[$k.'_Url'] =	$server_request_scheme.$d.'.'.$urlPart[count($urlPart)-2]. ".". $urlPart[count($urlPart)-1];//'http://'.$d.'.'.$urlPart[count($urlPart)-2]. ".". $urlPart[count($urlPart)-1];
		elseif(strpos($_SERVER['HTTP_HOST'], '.project') !== false)
			$virtual_path[$k.'_Url'] =	$server_request_scheme. $_SERVER['NON_WWW_HTTP_HOST'];
		else
//			$virtual_path[$k.'_Url'] =	$server_request_scheme.$d.'.'. $_SERVER['NON_WWW_HTTP_HOST'];//'http://'.$_SERVER['NON_WWW_HTTP_HOST'];
			$virtual_path[$k.'_Url'] =	$server_request_scheme. $_SERVER['NON_WWW_HTTP_HOST'];//'http://'.$_SERVER['NON_WWW_HTTP_HOST'];

	}

}
# Including required configuration
$physical_path['Site_Include']      =	$physical_path['Site_Root']. '/includes';

# Set library path
$physical_path['Libs']              =	$physical_path['Site_Root']. '/libs';
$virtual_path['Libs']               =	$virtual_path['CDN_Url'].$virtual_path['Site_Root']. '/libs';

# Define upload folder fake name
define('ENC_V_UP_FOLDER',           preg_replace("/[0-9]/", "", md5('image-office')));
# Define regular site url
define('REGULAR_SITE_URL',		    $server_request_scheme.$_SERVER['NON_WWW_HTTP_HOST']);

# Define rich html editor path
define('EDITOR_ROOT',               $physical_path['Libs']. '/ckeditor/' );
define('EDITOR_URL', 	            $virtual_path['Site_Root']. '/libs/ckeditor/');

# Get the basic data access
$physical_path['DB_Access']         =	$physical_path['Site_Root']. '/db_access';

# cronjob path
$physical_path['Cronjob']           =	$physical_path['Site_Root']. '/cronjob';

# Api Path
$physical_path['API']               =	$physical_path['Site_Root']. '/apis';

# File upload directory
$physical_path['Upload']            =	$physical_path['Site_Root']. '/upload';
$physical_path['Property_Upload']   =	'/mnt/volume_sfo2_01/upload';
$virtual_path['Upload']             =	$virtual_path['Site_Root']. '/upload';
$virtual_path['Property_Upload']    =	$virtual_path['Site_Root']. '/mnt/volume_sfo2_01/upload';
$virtual_path['ENC_Upload']         =	$virtual_path['Site_Root']. '/'.ENC_V_UP_FOLDER;

$physical_path['Temp_Upload']       =   $physical_path['Upload'].'/temp';
$virtual_path['Temp_Upload']        =   $virtual_path['Upload'].'/temp';
$virtual_path['ENC_Temp_Upload']    =	$virtual_path['ENC_Upload'].'/temp';
//echo "<pre>";print_r($physical_path);exit;
//echo "<pre>";print_r($virtual_path);exit;
# Define basic path
if(defined("IN_ADMIN"))
{
	$physical_path['User_Root']		=	$physical_path['Site_Root']. '/admin-zone';
	$virtual_path['User_Root']		=	$virtual_path['Site_Root']. '/admin-zone';
}
elseif(defined("IN_AGENT"))
{
	$physical_path['User_Root']		=	$physical_path['Site_Root']. '/agentsite';
	$virtual_path['User_Root']		=	$virtual_path['Site_Root'];
}
else
{
	$physical_path['User_Root']		=	$physical_path['Site_Root'];
	$virtual_path['User_Root']		=	$virtual_path['Site_Root'];
}

# Define template related paths
$physical_path['Templates_Root']	=	$physical_path['User_Root']. '/templates';
$virtual_path['Templates_Root']		=	$virtual_path['User_Root'].  '/templates';

$physical_path['TPL_css']           =	$physical_path['Templates_Root']. '/css';
$virtual_path['TPL_css']            =	$virtual_path['CDN_Url'].$virtual_path['Templates_Root']. '/css';
$virtual_path['TPL_js']             =	$virtual_path['CDN_Url'].$virtual_path['Templates_Root']. '/js';

$physical_path['TPL_images']        =	$physical_path['Templates_Root']. '/images';
if(strpos($_SERVER['HTTP_HOST'], 'thatsend') !== false)
{$virtual_path['TPL_images']         =	$virtual_path['Main_Host_Url'].$virtual_path['Templates_Root']. '/images';}
else
{$virtual_path['TPL_images']         =	$virtual_path['MDN_Url'].$virtual_path['Templates_Root']. '/images';}

# Email template
$physical_path['EmailTemplate']		=	$physical_path['Site_Root']. '/email_templates';
$virtual_path['EmailTemplate']		=	$virtual_path['Site_Root']. '/email_templates';

spl_autoload_register('db_access');
function db_access($class)
{
	global $physical_path;
	$path = $physical_path['DB_Access']. '/'.$class.'.php';

	if(file_exists($path)){require_once($path);}
}

# OE_ClientWindow functionality
/*require_once($physical_path['Libs']. '/OE_ClientWindow/cw.php');
cw::$obj = new cw(array('cookie_name'=>'crs_cw'));*/

# At initial load screen is not detected so set screen size as per assumption afer once screen will be detected it will be more perfect
/*if(cw::$screen == null)
{
	require_once($physical_path['Libs']. '/Mobile-Detect-2.8.19/OE_Mobile_Detect.php');
	dd::$obj = new dd();

	if(dd::$obj->isMobile() && !dd::$obj->isTablet())
		cw::$screen = CW_S_XS;
	elseif(dd::$obj->isTablet())
		cw::$screen = CW_S_MD;
	else
		cw::$screen = CW_S_XL;

    cw::$obj->SetApproxScreenDimention(cw::$screen);
}*/

//Utility::pre(cw::$obj);
# Include required files
require_once($physical_path['Site_Include']. '/constants.php');
require_once($physical_path['Site_Include']. '/static_data.php');
require_once($physical_path['Site_Include']. '/config.php');
//require_once($physical_path['Site_Include']. '/sys_config.php');
require_once($physical_path['Libs']. '/Ocrypt.php');
require_once($physical_path['Libs']. '/pdo-2.1.php');
require_once($physical_path['Libs']. '/mysqli5.php');

# For local individual project setup in laptop has different domain name so need to change it for localhost
if(defined("IN_AGENT") && (strpos($_SERVER['SERVER_NAME'],'-') 	!== false) && (strpos($_SERVER['SERVER_NAME'],'.project') 	!== false))
{
    $config['data_domain'] = $_SERVER['SERVER_NAME'];
    $config['agent_data_domain'] = str_replace(':'.$_SERVER['SERVER_PORT'],'',((strpos($_SERVER['HTTP_HOST'],'.project:'.$_SERVER['SERVER_PORT'])===false && strpos($_SERVER['HTTP_HOST'],'thatsend')===false)?'www.':'').((strpos($_SERVER['HTTP_HOST'], 'thatsend') !== false)?$urlPart[count($urlPart)-3].".". $urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1]:$urlPart[count($urlPart)-2].".".$urlPart[count($urlPart)-1]));
}
elseif(strpos($_SERVER['SERVER_NAME'],'-') <= 5)
{
    $config['data_domain'] = $_SERVER['SERVER_NAME'];
    $config['agent_data_domain'] = $_SERVER['SERVER_NAME'];
}
if(defined("IN_API") && isset($_POST['type']) && isset($_POST['cmd']) && $_POST['type'] == 'pic' && $_POST['cmd'] == 'property')
{

}
else
{
    global $db;
    $db = '';
    # Make the OE database connection
    $db = new DB_Sql($config[DB_HOST],$config[DB_NAME],$config[DB_USER],$config[DB_PASSWD],false);

    if(!$db->link_id())
    {
    	exit("Could not connect to the database");
    }
    //$db->query("SET NAMES 'utf8'");
    //$db->query("SET CHARACTER SET UTF8");
    //$Debug_info = $db->Debug_info;
    # Make the OE database connection
    DBc::$obj = new DBc($config[DB_HOST],$config[DB_USER],$config[DB_PASSWD],$config[DB_NAME],$config[DB_DRIVER],$config[DB_CHARSET],$config[DB_PORT]);
    if(!isset($config['OnLocal'])){DBc::$obj->Halt_On_Error('No');}

    if(!isset($config['OnLocal'])){$db->Halt_On_Error('no');}

    /*if(!defined("IN_ASSETS"))
    {
    	Utility::obj(true);
        //WebConfig::obj(true);
    	//ErrorLog::obj(true);
    	//SystemConfig::obj();
    }*/
}


foreach($asset['SUB_DOMAIN_LIST'] as $k=>$d){
	if(strpos($_SERVER['HTTP_HOST'], 'thatsend') !== false)
	{
		$virtual_path['Data_'.$k.'_Url'] =	$server_request_scheme. $config['agent_data_domain'];
	}
	elseif(strpos($_SERVER['HTTP_HOST'], 'project') !== false)
	{
		$virtual_path['Data_'.$k.'_Url'] =	$server_request_scheme.$d.'.'. $config['agent_data_domain'].":".$_SERVER["SERVER_PORT"];
	}

	else{
		$virtual_path['Data_'.$k.'_Url'] =	$server_request_scheme. $config['agent_data_domain'];//'http://'.$d.'.'. $config['agent_data_domain'];
	}
}


# Initiate user and start session
if((!defined("IN_API"))  && !defined("IN_ASSETS"))
{
	/*global $usrInfo;

	# Auth User object
	AuthUser::obj();

	# Get the logged user info
	switch(AuthUser::obj()->User_Perm)
	{
		# Admin
		case ADMIN:
		case SUBADMIN:
			$usrInfo = AdminMaster::obj(AuthUser::obj()->User_Id,true);
			AuthUser::obj()->UserID = AdminMaster::obj()->ID;
			break;
         # Agent Roster
		case AGENT:
			$usrInfo = AgentRoster::obj(AuthUser::obj()->User_Id, true);
			AuthUser::obj()->UserID = AgentRoster::obj()->ID;
			break;
		# User
		case USER:
			$usrInfo = IDXUser::obj(AuthUser::obj()->User_Id,true);
			AuthUser::obj()->UserID = $usrInfo->ID;
			break;

		# Crawler [Overwrite max.no of listing display restriction for Search Engine]
		case CRAWLER:
			define('IN_CRAWLER', true);

			# If screen is not detected then do manipulation for crawler as javascript will not execute
			/*if(cw::$screen == false)
			{
				require_once($physical_path['Libs']. '/Mobile-Detect-2.8.19/OE_Mobile-Detect.php');
				dd::$obj = new dd();
				if(dd::$obj->isMobile() && !dd::$obj->isTablet())
				{
					cw::$screen = CW_S_XS;
					runkit_constant_redefine('RESULT_PAGESIZE', RESULT_PAGESIZE_MOBILE);
				}
				elseif(dd::$obj->isTablet())
				{
					cw::$screen = CW_S_MD;
				}
				else
				{
					cw::$screen = CW_S_XL;
				}
			}*/
			//break;

		# Anonymous User
		/*case ANONYMOUS:

			break;*/
	/*}*/
}
?>
