<?php
function smarty_function_html_pagination_website($params, &$smarty)
{
	extract($params);

	$path_parts	= isset($_SERVER['REDIRECT_URL'])?pathinfo($_SERVER['REDIRECT_URL']):pathinfo("/");

	$query_string = substr($_SERVER['QUERY_STRING'], 0, strpos($_SERVER['QUERY_STRING'],"&page")===false?strlen($_SERVER['QUERY_STRING']):strpos($_SERVER['QUERY_STRING'],"&page"));
	$query_string = substr($query_string, 0, strpos($query_string,"page")===false?strlen($query_string):strpos($query_string,"page"));
	$base_url = $path_parts["basename"].(!empty($query_string)?'?'.$query_string:'');

	$total_pages = ceil($num_items/$per_page);

	if ( $total_pages == 1 )
		return '';

	$on_page = floor($start_item / $per_page) + 1;

	$page_string = '';
	//$pagination_type == 'lg' $pagination_type == 'sm'
	if($total_pages > 10)
	{
		$init_page_max = ( $total_pages > 3 ) ? 3 : $total_pages;
		for($i = 1; $i < $init_page_max + 1; $i++)
		{
			$page_string .= smarty_function_html_pagination_link($i, $on_page, $per_page, $base_url);
			//if ( $i <  $init_page_max )
			//  $page_string .= ' ';
		}

		if ( $on_page > 1  && $on_page < $total_pages )
		{
			$page_string .= ( $on_page > 5 ) ? '<li class="page-item disabled"><a class="page-link" href="javascript:void(0);">...</a></li>' : '';
			$init_page_min = ( $on_page > 4 ) ? $on_page : 5;
			$init_page_max = ( $on_page < $total_pages - 4 ) ? $on_page : $total_pages - 4;

			for($i = $init_page_min - 1; $i < $init_page_max + 2; $i++)
			{
				$page_string .= smarty_function_html_pagination_link($i, $on_page, $per_page, $base_url);
				//if ( $i <  $init_page_max + 1 )
				//  $page_string .= ' ';
			}
			$page_string .= ( $on_page < $total_pages - 4 ) ? '<li class="page-item disabled"><a class="page-link" href="javascript:void(0);">...</a></li>' : '';
		}
		else
			$page_string .= '<li class="page-item disabled"><a class="page-link" href="javascript:void(0);">...</a></li>';

		for($i = $total_pages - 2; $i < $total_pages + 1; $i++)
		{
			$page_string .= smarty_function_html_pagination_link($i, $on_page, $per_page, $base_url);
			//if( $i <  $total_pages )
			//  $page_string .= " ";
		}
	}
	else
	{
		for($i = 1; $i < $total_pages + 1; $i++)
		{
			$page_string .= smarty_function_html_pagination_link($i, $on_page, $per_page, $base_url);
			//if ( $i <  $total_pages )
			//  $page_string .= " ";
		}
	}

	if(isset($add_prevnext_text))
	{
		if($on_page > 1)
		{
            if(defined('IN_AJAX'))
            {
                $page_string =
        			'<li class="page-item"><a class="page-link page" rel="1" href="javascript:void(0);"><i class="fa fa-step-backward"></i></a></li>
                    <li class="page-item"><a class="page-link page" rel="'.($on_page-1).'" href="javascript:void(0);" id="previous-page"><i class="fa fa-backward"></i></a></li>'
        			.$page_string;
            }
            else
            {
        		$page_string =
        			'<li class="page-item"><a class="page-link page" rel="1" href="'.Utility::obj()->pad_query_string($base_url,'page=1').'"><i class="fa fa-step-backward"></i></a></li>
                    <li class="page-item"><a class="page-link page" rel="'.($on_page-1).'" href="'.Utility::obj()->pad_query_string($base_url,'page='.($on_page-1)).'" id="previous-page"><i class="fa fa-backward"></i></a></li>'
        			.$page_string;
            }
		}
		else
		{
			$page_string =
				'<li class="page-item disabled"><a class="page-link" href="javascript:void(0);"><i class="fa fa-step-backward"></i></a></li>
            	<li class="page-item disabled"><a class="page-link" href="javascript:void(0);"><i class="fa fa-backward"></i></a></li>'
				.$page_string;
		}

		if($on_page < $total_pages)
		{
            if(defined('IN_AJAX'))
            {
                $page_string .=
    				'<li class="page-item"><a class="page-link page" rel="'.($on_page+1).'" href="javascript:void(0);" id="next-page"><i class="fa fa-forward"></i></a></li>
                    <li class="page-item"><a class="page-link page" rel="'.$total_pages.'" href="javascript:void(0);"><i class="fa fa-step-forward"></i></a></li>';
            }
            else
            {
    			$page_string .=
    				'<li class="page-item"><a class="page-link page" rel="'.($on_page+1).'" href="'.Utility::obj()->pad_query_string($base_url,'page='.($on_page+1)).'" id="next-page"><i class="fa fa-forward"></i></a></li>
                    <li class="page-item"><a class="page-link page" rel="'.$total_pages.'" href="'.Utility::obj()->pad_query_string($base_url,'page='.$total_pages).'"><i class="fa fa-step-forward"></i></a></li>';
            }
        }
		else
		{
			$page_string .=
				'<li class="page-item disabled"><a class="page-link" href="javascript:void(0);"><i class="fa fa-forward"></i></a></li>
            	<li class="page-item disabled"><a class="page-link" href="javascript:void(0);"><i class="fa fa-step-forward"></i></a></li>';
		}
	}

	$page_string = '<ul class="pagination '.(isset($class)?$class:'').'">'.$page_string.'</ul>';

	echo $page_string;
}
function smarty_function_html_pagination_link($page, $on_page, $per_page, $base_url)
{
	$url    = defined('IN_AJAX')?'javascript:void(0);':Utility::obj()->pad_query_string($base_url,'page='.$page);
	$link   = ($page == $on_page)   ?'<li class="page-item active"><a class="page-link" href="javascript:void(0);">'.$page.'</a></li>'
									:'<li class="page-item"><a class="page-link page" href="'.$url.'" rel="'.$page.'">'.$page.'</a></li>';
	return $link;
}
?>
