<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {sprintf_byfield} function plugin
 *
 * Type:     function<br>
 * Name:     sprintf_byfield<br>
 * Purpose:  handle sprintf_byfield computations in template<br>
 * @author   Niravraj Parmar
 * @param array
 * @param Smarty
 * @return string
 */
function smarty_function_sprintf_byfield($params, &$smarty)
{
    # Be sure parameters are present
    if (count($params) < 2)
    {
        $smarty->trigger_error("Missing parameters");
        return;
    }
    $values =   array_intersect_key($params['field_data'], array_flip($params['field_list']));

	if(isset($params['encrypt_data']) && $params['encrypt_data'] === true)
	{
		foreach($values as $field => $value)
			$values[$field] = Ocrypt::enc($value);
	}

    $out    =   vsprintf($params['format'], $values);
    echo $out;
}
?>