<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty plugin
 *
 * Type:     modifier<br>
 * Name:     in_array<br>
 * Date:     Jan 08, 2004
 * Purpose:  Searches haystack for needle and returns TRUE if it is found in the array, FALSE otherwise
 * Input:<br>
 *         - needle = mixed needle
 *         - haystack = array haystack 
 *         - strict = strict check
 * Example:  {$needle|in_array:$haystack:$strict}
 * @version  1.0
 * @param string
 * @return string
 */
function smarty_modifier_array_value_list($key, $array, $splitBy="|", $format='')
{
/*	print "<br>=============================<br>";
	print_r($key);
	print "<br>=============================<br>";
	print_r($array);
	print "<br>";
	echo "split by".$splitBy;*/
//	print "<br>";
//	print "<br><br>";

	if(!is_array($array))
		return false;
		
	$key_array = explode($splitBy,$key);
	$selected_value_list = '';
	foreach($key_array as $id=>$key)
	{
		if (!empty($array[$key]))
		{
			$value = $array[$key];	
			if(!empty($format))
				$value = sprintf($format, $value);
				
			$selected_value_list .= $value.", ";
		}
	}
	
	/* remove trailing commas*/
	$selected_value_list = trim($selected_value_list,", ");
    
	return $selected_value_list;
}

/* vim: set expandtab: */

?>
