<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty strip modifier plugin
 *
 * Type:     modifier<br>
 * Name:     strip<br>
 * Purpose:  Remove all repeated spaces, newlines, tabs, html tags
 *           with a single space or supplied replacement string.<br>. 
 * Example:  {$var|strip} {$var|strip:"&nbsp;"}
 * Date:     November 11th, 2013
 * @link http://smarty.php.net/manual/en/language.modifier.strip.php
 *          strip (Smarty online manual)
 * @author   Niravraj Parmar
 * @version  1.0
 * @param string
 * @param string
 * @return string
 */
function smarty_modifier_remove_html($text)
{    
    /*$out    =   preg_replace('!<[^>]*?>!', ' ', $text);*/
    $out    =   preg_replace('#<br\s*/?>#', "\n", $text);
    $out    =   preg_replace("!<style[^>]+>.*?</style>!is", '', $out);
    $out    =   strip_tags($out);
    $out    =   preg_replace("/[\n\r]+/", "\n", $out);
    $out    =   preg_replace("/[\s]+/", " ", $out);
    $out    =   preg_replace("/[.]+/", ".\n", $out);
    $out    =   preg_replace("/[\n]+/", "\n", $out);
    $out    =   trim($out);
    return $out;
}
?>
